--[[
Most of this is done rather the quick and REALLY REALLY dirty way...
]]

local WM = WINDOW_MANAGER;
local LSF = LibStub:GetLibrary("LibSkillsFactory");
LSF:InitSkillFactory(GetUnitClassId("player"), GetUnitRaceId("player"));

function AuraMastery:GetAbilityIdsByName() -- thx Ayantir
  
	  local ABILITY_TYPE_ULTIMATE = 0
	  local ABILITY_TYPE_ACTIVE = 1
	  
	  local MORPH_TYPE_BASE = 0
	  local MORPH_TYPE_UPPER = 1
	  local MORPH_TYPE_LOWER = 2
	  
	  if not self.abilityData then self.abilityData = {} end
	  
	  local lang = GetCVar("Language.2")
	  self.abilityData[lang] = {}
	  
	  for skillType=1, 6 do
			for skillLineIndex=1, LSF:GetNumSkillLines(skillType) do
				 for abilityIndex=1, LSF:GetNumSkillAbilities(skillType, skillLineIndex) do
					  
					  local abilityType = LSF:GetAbilityType(skillType, skillLineIndex, abilityIndex)
					  
					  if abilityType == ABILITY_TYPE_ULTIMATE or abilityType == ABILITY_TYPE_ACTIVE then
					  
							local abilityIdRank1NoMorph, abilityIdRank2NoMorph,abilityIdRank3NoMorph, abilityIdRank4NoMorph
							local abilityIdRank1UpperMorph, abilityIdRank2UpperMorph,abilityIdRank3UpperMorph, abilityIdRank4UpperMorph
							local abilityIdRank1LowerMorph, abilityIdRank2LowerMorph,abilityIdRank3LowerMorph, abilityIdRank4LowerMorph
							
							abilityIdRank1NoMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_BASE, 1)
							abilityIdRank2NoMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_BASE, 2)
							abilityIdRank3NoMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_BASE, 3)
							abilityIdRank4NoMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_BASE, 4)
							
							abilityIdRank1UpperMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_UPPER, 1)
							abilityIdRank2UpperMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_UPPER, 2)
							abilityIdRank3UpperMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_UPPER, 3)
							abilityIdRank4UpperMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_UPPER, 4)
							
							abilityIdRank1LowerMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_LOWER, 1)
							abilityIdRank2LowerMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_LOWER, 2)
							abilityIdRank3LowerMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_LOWER, 3)
							abilityIdRank4LowerMorph = LSF:GetAbilityId(skillType, skillLineIndex, abilityIndex, MORPH_TYPE_LOWER, 4)
							
							local abilityNameNoMorph    = zo_strformat("<<z:1>>", GetAbilityName(abilityIdRank1NoMorph))
							local abilityNameUpperMorph = zo_strformat("<<z:1>>", GetAbilityName(abilityIdRank1UpperMorph))
							local abilityNameLowerMorph = zo_strformat("<<z:1>>", GetAbilityName(abilityIdRank1LowerMorph))
							
							self.abilityData[lang][abilityNameNoMorph] = {
								 rank1 = abilityIdRank1NoMorph,
								 rank2 = abilityIdRank2NoMorph,
								 rank3 = abilityIdRank3NoMorph,
								 rank4 = abilityIdRank4NoMorph,
							}
							
							self.abilityData[lang][abilityNameUpperMorph] = {
								 rank1 = abilityIdRank1UpperMorph,
								 rank2 = abilityIdRank2UpperMorph,
								 rank3 = abilityIdRank3UpperMorph,
								 rank4 = abilityIdRank4UpperMorph,
							}
							
							self.abilityData[lang][abilityNameLowerMorph] = {
								 rank1 = abilityIdRank1LowerMorph,
								 rank2 = abilityIdRank2LowerMorph,
								 rank3 = abilityIdRank3LowerMorph,
								 rank4 = abilityIdRank4LowerMorph,
							}
							
					  end
					  
				 end
			end
	  end
	  
 end

function AuraMastery:CreateMenu()
	self:CreateAurasList();
	self:CreateIconSelect();

	-- todo: Dynamize it later...

	local parent = WM:GetControlByName("AuraMasteryMenuContainer");
	local button = WM:CreateControl("AuraMasteryMenuCloseButton", parent, CT_BUTTON);
	button:SetDimensions(24,24);
	button:SetAnchor(TOPRIGHT, parent, TOPRIGHT, -5, 5);
	button:SetClickSound('Click');
	button:SetNormalTexture("/esoui/art/buttons/decline_up.dds");
	button:SetMouseOverTexture("/esoui/art/buttons/decline_over.dds");
	button:SetPressedTexture("/esoui/art/buttons/decline_down.dds");
	button:SetHandler("OnClicked", function(self) self:GetParent():SetHidden(true); end);

	local parent = WM:GetControlByName("AuraMasteryMenuAuraListContainer");
	local button = WM:GetControlByName("NewAuraButton");
	button:SetFont("$(BOLD_FONT)|18|soft-shadow-thin");
   button:SetNormalFontColor(1,.45,0,1);
	button:SetMouseOverFontColor(.95,.75,0,1);
	button:SetHorizontalAlignment(TEXT_ALIGN_CENTER);
	button:SetVerticalAlignment(TEXT_ALIGN_CENTER);
	button:SetNormalOffset(0,0);
	button:SetPressedOffset(1,1);
	button:SetText("Create new aura");

	local parent = WM:GetControlByName("EditIconButton");
	local arrow = WM:CreateControl("$(parent)_arrow", parent, CT_TEXTURE);
	arrow:SetDimensions(14,14);
	arrow:SetAnchor(RIGHT, parent, RIGHT, -4);
	arrow:SetTexture("/esoui/art/buttons/dropbox_arrow_normal.dds");
	parent:SetHandler("OnMouseEnter", function(self) self:GetNamedChild("_arrow"):SetTexture("/esoui/art/buttons/dropbox_arrow_mouseover.dds"); end);
	parent:SetHandler("OnMouseExit", function(self) self:GetNamedChild("_arrow"):SetTexture("/esoui/art/buttons/dropbox_arrow_normal.dds"); end);
	parent:SetHandler("OnMouseDown", function(self) self:GetNamedChild("_arrow"):SetTexture("/esoui/art/buttons/dropbox_arrow_mousedown.dds"); end);
	parent:SetHandler("OnMouseUp", function(self) self:GetNamedChild("_arrow"):SetTexture("/esoui/art/buttons/dropbox_arrow_mouseover.dds"); end );
end

function AuraMastery:CreateAurasList()
	local parent = WM:GetControlByName("AuraMasteryMenuAuraListContainer");
	local i = 1;
	for k, v in pairs(self.svars.auraData) do
		self:CreateAurasListItem(k, i);
		i=i+1;
	end
	self:SortAurasList();
end

function AuraMastery:CreateAurasListItem(auraName, number)
	local parent			= WM:GetControlByName("AuraMasteryMenuAuraListContainer");
	local button 			= WM:GetControlByName("AuraMastery_"..auraName);

	if button then
		button:SetHidden(false);
		backdrop 		= WM:GetControlByName("AuraMastery_"..auraName.."_Backdrop");
		deleteButton	= WM:GetControlByName("AuraMastery_"..auraName.."DeleteButton");
	else
		button 			= WM:CreateControl("AuraMastery_"..auraName, parent, CT_BUTTON);
		backdrop 		= WM:CreateControl("$(parent)_Backdrop", button, CT_BACKDROP);
		deleteButton	= WM:CreateControl("$(parent)DeleteButton", button, CT_BUTTON);
	end

	button.id=auraName;
	button:SetDimensions(292, 50);
	button:SetAnchor(TOPLEFT, parent, TOPLEFT, 4, 60+((number-1)*50)+4+(2*(number-1)));
	button:SetClickSound('Click');
	button:SetFont("$(BOLD_FONT)|18|soft-shadow-thin");
   button:SetNormalFontColor(.95,.75,0,1);
	button:SetMouseOverFontColor(.95,.75,0,.5);
	button:SetHorizontalAlignment(TEXT_ALIGN_LEFT);
	button:SetVerticalAlignment(TEXT_ALIGN_CENTER);
	button:SetNormalOffset(10,0);
	button:SetPressedOffset(11,1);
	button:SetText(auraName);
	button:SetHandler("OnMouseEnter", function(self) self:GetChild(1):SetCenterColor(1,.6,0,.25); end);
	button:SetHandler("OnMouseExit", function(self) self:GetChild(1):SetCenterColor(0,0,0,.4); end);
	button:SetHandler("OnClicked", function(self) AuraMastery:LoadAuraMenu(self.id) end);

	backdrop:SetAnchorFill();
	backdrop:SetCenterColor(0,0,0,.4);
	backdrop:SetEdgeTexture(nil, 1, 1, 1, 0);
	backdrop:SetEdgeColor(.12,.12,.12);

	deleteButton.id=auraName;
	deleteButton:SetDimensions(24,24);
	deleteButton:SetAnchor(RIGHT, button, RIGHT, -10);
	deleteButton:SetClickSound('Click');
	deleteButton:SetNormalTexture("/esoui/art/buttons/decline_up.dds");
	deleteButton:SetMouseOverTexture("/esoui/art/buttons/decline_over.dds");
	deleteButton:SetPressedTexture("/esoui/art/buttons/decline_down.dds");
	deleteButton:SetHandler("OnClicked", function(self) AuraMastery:DeleteAura(self.id) end);
end

function AuraMastery:SortAurasList()
	local i = 1;
	for k, v in self:pairsByKeys(self.svars.auraData) do
		local control = WM:GetControlByName("AuraMastery_"..k);

		if control then control:SetAnchor(TOPLEFT, parentElement, TOPLEFT, 4, 60+((i-1)*50)+4+(2*(i-1))); else table.insert(self.buffer, "Element nicht gefunden: "..k) end
		i = i+1;
	end
end

function AuraMastery:LoadNewAuraMenu()
	WM:GetControlByName("AuraMasteryMenu_EditAura"):SetHidden(true);
	WM:GetControlByName("AuraMasteryMenu_NewAura"):SetHidden(false);
end

function AuraMastery:LoadEditAuraMenu()
	WM:GetControlByName("AuraMasteryMenu_NewAura"):SetHidden(true);
	WM:GetControlByName("AuraMasteryMenu_EditAura"):SetHidden(false);
end

function AuraMastery:LoadAuraMenu(auraName)
	self:CollapseMenu();
	WM:GetControlByName("AuraMasteryMenu_NewAura"):SetHidden(true);
	WM:GetControlByName("AuraMasteryMenu_EditAura"):SetHidden(false);

	if not auraName then d("Fehler: Keine Auradaten übergeben."); return; end
	
	self.activeAura = auraName;

	local EBName = WM:GetControlByName("EditboxName");
	EBName:SetText(auraName);

	local EBWidth = WM:GetControlByName("EditboxWidth");
	EBWidth:SetText(AuraMastery.svars.auraData[auraName].width);

	local EBHeight = WM:GetControlByName("EditboxHeight");
	EBHeight:SetText(self.svars.auraData[auraName].height);

	local EBPosX = WM:GetControlByName("EditboxPosX");
	EBPosX:SetText(self.svars.auraData[auraName].posX);

	local EBPosY = WM:GetControlByName("EditboxPosY");
	EBPosY:SetText(self.svars.auraData[auraName].posY);

	local EBAlpha = WM:GetControlByName("EditboxAlpha");
	EBAlpha:SetText(self.svars.auraData[auraName].alpha);

	local EBBorderSize = WM:GetControlByName("EditboxBorderSize");
	EBBorderSize:SetText(self.svars.auraData[auraName].borderSize);

	local EBFontSize = WM:GetControlByName("EditboxFontSize");
	EBFontSize:SetText(self.svars.auraData[auraName].fontSize);

	local EBCritical = WM:GetControlByName("EditboxCritical");
	EBCritical:SetText(self.svars.auraData[auraName].critical);

	self:CreateTriggersList();
end

function AuraMastery:TempDropdown(controlName)
	local control = WM:GetControlByName(controlName);
	if control:IsHidden() then control:SetHidden(false); else control:SetHidden(true); end
end

function AuraMastery:NewIcon()
	self:CollapseMenu();
	self.activeAura = nil;
	self:LoadEditAuraMenu();

	self.counter	= 0;
	self.ATN			= "New Aura";
	self.finalName = nil;

	self:CheckNewName();
	
	local parent = WM:GetControlByName("AuraMasteryMenuAuraListContainer");
	local auraName = self.finalName;
	local i = self:GetNumElements(self.svars.auraData);
	--self:CreateNewAura(auraName, auraType, critical, width, height, alpha, color, borderSize, borderColor, bgColor, posX, posY, fontSize, iconPath)
	self:CreateNewAura(auraName, 1,0,0,0,0,{0,0,0},0,{0,0,0},{0,0,0},0,0,0,"");
	self.activeAura = auraName;
	self:CreateAurasListItem(auraName, i);
	self:SortAurasList();
	self:LoadAuraMenu(auraName);
end

function AuraMastery:CheckNewName()
	local free = true;
	local testname = (0 == AuraMastery.counter and AuraMastery.ATN) or self.ATN.." ("..self.counter..")";
	for k, v in pairs(self.svars.auraData) do
		if (k == testname) then
			self.counter = self.counter+1;
			free = false;
			self:CheckNewName();
			break;
		end
	end
	if free then self.finalName = testname; end -- DEBUGGING: self.counter = 0 setzen? (wird eigentlich schon in NewIcon() gemacht)
end

function AuraMastery:ChangeAuraName()
	if not(self.activeAura) then d("Keine aktive Aura gesetzt beim Updateversuch."); return; end
	local control = WM:GetControlByName("EditboxName");
	local oldName = self.activeAura;
	local newName = self:trim(control:GetText());

	-- User Input: Sicherheitsabfragen
	if ((not(newName)) or "" == newName) then d("Please enter a name.") return; end
	--if (newName == oldName) then return; end
	if (self.svars.auraData[newName]) then d("This name is already taken by another aura."); return; end

	-- Einträge mit neuem Namen erstellen:
	-- 1. Controlreferenz
	self.aura[newName] = self.aura[oldName];
	-- 2. SVars
	self.svars.auraData[newName] = self.svars.auraData[oldName];
	-- 3. LoadedAuras
	self:LoadAura(newName);
	-- 4. Auramenu:List
	local number = self:GetNumElements(self.svars.auraData);
	self:CreateAurasListItem(newName, number);

	-- Einträge unter altem Namen löschen
	-- 1. Aura im updater deregistrieren
	self:UnloadAura(oldName);
	-- 2. Controlreferenz entfernen
	WM:GetControlByName("AuraMastery_"..oldName):SetHidden(true);
	-- 3. SVars
	self:RemoveAuraControl(oldName);
	self.svars.auraData[oldName] = nil;
	-- Neue Aura aktiv setzen
	self.activeAura = newName;
	self:SortAurasList();
	WM:GetControlByName("EditboxName"):LoseFocus();
end

function AuraMastery:CreateNewAura(auraName, auraType, critical, width, height, alpha, color, borderSize, borderColor, bgColor, posX, posY, fontSize, iconPath)
	local aura = {
		['auraType'] = 1,	-- icon, [label, status bar]
		['triggers'] = {
		},
		['critical']		= critical,
		['width']			= width,
		['height']			= height,
		['alpha']			= alpha,
		['color']			= {0,0,0,1},
		['borderSize']    = borderSize,
		['borderColor']	= {0,0,0,1},
		['bgColor']			= {0.2,0.2,0.2,0.4},
		['posX']				= posX,
		['posY']				= posY,
		['fontSize']		= fontSize,
		['iconPath']		= "",
	}
	self.svars.auraData[auraName] = aura;
	self:CreateAuraControl(auraName);
	self:LoadAura(auraName);
end

function AuraMastery:DeleteAura(auraName)
	self:UnloadAura(auraName);
	self:RemoveAuraControl(auraName);
	self:RemoveAuraData(auraName);
	self.activeAura = nil;
	WM:GetControlByName("AuraMastery_"..auraName):SetHidden(true);	-- Menüanzeigeelement verbergen
	WM:GetControlByName("AuraMasteryMenu_NewAura"):SetHidden(true);
	WM:GetControlByName("AuraMasteryMenu_EditAura"):SetHidden(true);
	self:SortAurasList();
end

function AuraMastery:CreateIconSelect()
	local parent = WM:GetControlByName("AuraMasteryMenuIconSelectMain");
	local counter = 0;
	for k,v in self:pairsByKeys(self.iconData) do
		local innerCounter = 0;
		local iconset = WM:CreateControl("AuraMasteryMenuIconSelectMain"..k, parent, CT_BUTTON);
		iconset:SetDimensions(164,25);
		iconset:SetAnchor(TOPLEFT, parent, TOPLEFT, 0, counter*25);
		iconset.bg = WM:CreateControl("$(parent)_Backdrop", iconset, CT_BACKDROP);
		iconset.bg:SetAnchorFill();
		iconset.bg:SetCenterColor(0,0,0,0);
		iconset.bg:SetEdgeTexture(nil,1,1,1,0);
		iconset.bg:SetEdgeColor(0,0,0,0);
		iconset.label = WM:CreateControl("$(parent)_Label", iconset, CT_LABEL);
		iconset.label:SetAnchor(LEFT, iconset, LEFT, 4);
		iconset.label:SetFont("$(BOLD_FONT)|14|soft-shadow-thin");
		iconset.label:SetColor(1,1,1);
		iconset.label:SetText(k);
		iconset.expand = WM:CreateControl("$(parent)_arrow", iconset, CT_TEXTURE);
		iconset.expand:SetDimensions(14,14);
		iconset.expand:SetAnchor(RIGHT, iconset, RIGHT, -4);
		iconset.expand:SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_up.dds");
		iconset.k = k;
		iconset:SetHandler("OnMouseEnter", function(self) AuraMastery:Highlight("AuraMasteryMenuIconSelectMain"..self.k.."_Backdrop", "background", 1,.6,0,.25); self:GetNamedChild("_arrow"):SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_over.dds"); end);
		iconset:SetHandler("OnMouseExit", function(self) AuraMastery:Highlight("AuraMasteryMenuIconSelectMain"..self.k.."_Backdrop", "background", 0,0,0,.4); self:GetNamedChild("_arrow"):SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_up.dds"); end);
		iconset:SetHandler("OnClicked", function(self) AuraMastery:TempDropdown("AuraMasteryMenuIconSelectMain"..self.k.."CategoryContainer"); end);
		iconset:SetHandler("OnMouseDown", function(self) self:GetNamedChild("_arrow"):SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_down.dds"); end);
		iconset:SetHandler("OnMouseUp", function(self) self:GetNamedChild("_arrow"):SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_over.dds"); end );

		local numChilds = self:GetNumElements(v);

		local categoryContainer = WM:CreateControl("$(parent)CategoryContainer", iconset, CT_CONTROL);
		categoryContainer:SetHidden(true);
		categoryContainer:SetDimensions(164,numChilds*25);
		categoryContainer:SetAnchor(TOPLEFT, iconset, TOPRIGHT);
		categoryContainer.bg = WM:CreateControl("$(parent)_Backdrop", categoryContainer, CT_BACKDROP);
		categoryContainer.bg:SetAnchorFill();
		categoryContainer.bg:SetCenterColor(0,0,0,.4);
		categoryContainer.bg:SetEdgeTexture(nil,1,1,1,0);
		categoryContainer.bg:SetEdgeColor(1,1,1,.12);

		counter = counter+1;

		for cat, cont in self:pairsByKeys(v) do
			--table.insert(self.buffer, "    "..cat.." => "..tostring(cont));
			local button = WM:CreateControl("AuraMasteryMenuIconSelectMain"..cat, categoryContainer, CT_BUTTON);
			button:SetDimensions(164,25);
			button:SetAnchor(TOPLEFT, categoryContainer, TOPLEFT, 0, innerCounter*25);
			button.bg = WM:CreateControl("$(parent)_Backdrop", button, CT_BACKDROP);
			button.bg:SetAnchorFill();
			button.bg:SetCenterColor(0,0,0,0);
			button.bg:SetEdgeTexture(nil,1,1,1,0);
			button.bg:SetEdgeColor(0,0,0,0);
			button.label = WM:CreateControl("$(parent)_Label", button, CT_LABEL);
			button.label:SetAnchor(LEFT, button, LEFT, 4);
			button.label:SetFont("$(BOLD_FONT)|14|soft-shadow-thin");
			button.label:SetColor(1,1,1);
			button.label:SetText(cat);
			button.cat = cat;
			button.expand = WM:CreateControl("$(parent)_arrow", button, CT_TEXTURE);
			button.expand:SetDimensions(14,14);
			button.expand:SetAnchor(RIGHT, button, RIGHT, -4);
			button.expand:SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_up.dds");
			button:SetHandler("OnMouseEnter", function(self) AuraMastery:Highlight("AuraMasteryMenuIconSelectMain"..self.cat.."_Backdrop", "background", 1,.6,0,.25); self:GetNamedChild("_arrow"):SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_over.dds"); end);
			button:SetHandler("OnMouseExit", function(self) AuraMastery:Highlight("AuraMasteryMenuIconSelectMain"..self.cat.."_Backdrop", "background", 0,0,0,.4); self:GetNamedChild("_arrow"):SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_up.dds"); end);
			button:SetHandler("OnClicked", function(self) AuraMastery:TempDropdown("AuraMasteryMenuIconSelectMain"..self.cat.."CategoryIconsContainer"); end);
			button:SetHandler("OnMouseDown", function(self) self:GetNamedChild("_arrow"):SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_down.dds"); end);
			button:SetHandler("OnMouseUp", function(self) self:GetNamedChild("_arrow"):SetTexture("/esoui/art/miscellaneous/spinnerarrow_right_over.dds"); end );

			local iconsPerRow = 18;
			local numIcons = self:GetNumElements(cont);
			local padding = 4;
			local iconSize = 32;
			local width = iconSize+padding;
			local height = width;

			local contentContainer = WM:CreateControl("$(parent)CategoryIconsContainer", button, CT_CONTROL);
			contentContainer:SetHidden(true);



			contentContainer:SetDimensions((iconsPerRow*width)+padding, (math.ceil(numIcons/iconsPerRow)*height)+padding);
			contentContainer:SetAnchor(TOPLEFT, button, TOPRIGHT);
			contentContainer.bg = WM:CreateControl("$(parent)_Backdrop", contentContainer, CT_BACKDROP);
			contentContainer.bg:SetAnchorFill();
			contentContainer.bg:SetCenterColor(0,0,0,.4);
			contentContainer.bg:SetEdgeTexture(nil,1,1,1,0);
			contentContainer.bg:SetEdgeColor(1,1,1,.12);

			self:CreateIconTextures(cont, "AuraMasteryMenuIconSelectMain"..cat.."CategoryIconsContainer");

			innerCounter = innerCounter+1;
		end

	end
end

function AuraMastery:CreateIconTextures(icons, parentName)
	local oX = 0;
	local oY = 0;
	local iconSize = 32;
	local padding  =  4;

	local parent = WM:GetControlByName(parentName);

	local iconsPerRow = 18;

	for k,v in pairs(icons) do
		local modX = (k-1)%iconsPerRow;
		local modY = math.floor((k-1)/iconsPerRow);

		oX = (modX*iconSize)+((modX+1)*padding);
		oY = (modY*iconSize)+((modY+1)*padding);

		--oX = (k-1)*(iconSize+padding);
		--oY = padding;

		local iconContainer = WM:CreateControl(parentName.."Icon"..k, parent, CT_BUTTON);
		iconContainer:SetDimensions(iconSize, iconSize);
		iconContainer:ClearAnchors();
		iconContainer:SetAnchor(TOPLEFT, parent, TOPLEFT, oX, oY);
		iconContainer.iconnr = k;
		iconContainer.iconPath = v;
		iconContainer:SetClickSound('Click');

		local icon = WM:CreateControl("$(parent)_Texture", iconContainer, CT_TEXTURE);
		icon:ClearAnchors();
		icon:SetAnchorFill();
		icon:SetDimensions(iconSize,iconSize);
		icon:SetTexture(v);
		
		iconContainer:SetHandler("OnMouseEnter", function(self) self:GetNamedChild("_Texture"):SetColor(1,1,1,.25) end);
		iconContainer:SetHandler("OnMouseExit", function(self) self:GetNamedChild("_Texture"):SetColor(1,1,1,1) end);
		iconContainer:SetHandler("OnClicked", function(self) AuraMastery:EditAuraIcon(AuraMastery.activeAura, self.iconPath); end);
	end
	
end

--** TRIGGERS LIST **--

function AuraMastery:CreateTriggersList()
	local arrow = WM:GetControlByName("TriggersDropdownListButton_arrow");
	arrow:SetTexture("/esoui/art/buttons/dropbox_arrow_normal.dds");
	WM:GetControlByName("AuraMasteryTriggerSettingsContainer"):SetHidden(true);
	self:ClearTriggersList();
	self.activeTrigger = nil;

	for k, v in pairs(self.svars.auraData[self.activeAura].triggers) do
		self:CreateTriggersListItem(k, self.activeAura);
	end
end

function AuraMastery:ClearTriggersList()
	local parent = WM:GetControlByName("TriggersDropdownList");
	WM:GetControlByName("TriggersDropdownListButton_Label"):SetText("Select condition");
	local i = 1;
	while parent:GetChild(i) do
		parent:GetChild(i):SetHidden(true);
		i = i + 1;
	end
end

function AuraMastery:CreateTriggersListItem(number, auraName)
	local parent			= WM:GetControlByName("TriggersDropdownList");
	local button 		= WM:GetControlByName(auraName.."TriggersMenuItem"..number);
	local backdrop = nil;
	local label = nil;

	if button then
		backdrop 		= WM:GetControlByName(auraName.."TriggersMenuItem"..number.."_Backdrop");
		label				= WM:GetControlByName(auraName.."TriggersMenuItem"..number.."_Label");
		button:SetHidden(false);
	else
		button 	= WM:CreateControl(auraName.."TriggersMenuItem"..number, parent, CT_BUTTON);
		backdrop = WM:CreateControl("$(parent)_Backdrop", button, CT_BACKDROP);
		label		= WM:CreateControl("$(parent)_Label", button, CT_LABEL);
	end


	button:SetDimensions(140, 25);
	button:SetAnchor(TOPLEFT, parentElement, TOPLEFT, 0, (number-1)*25);
	button:SetClickSound('Click');

	backdrop:SetAnchorFill();
	backdrop:SetCenterColor(0,0,0,0);
	backdrop:SetEdgeTexture(nil, 1, 1, 1, 0);
	backdrop:SetEdgeColor(0,0,0,0);

	label:SetAnchor(TOP, button, TOP);
	label:SetColor(1,1,1);
	label:SetFont("$(BOLD_FONT)|14|soft-shadow-thin");
	label:SetText("Condition "..number);

	button.number = number;
	button.auraName = auraName;

	button:SetHandler("OnMouseEnter", function(self) AuraMastery:Highlight(self.auraName.."TriggersMenuItem"..self.number.."_Backdrop", "background", 1,.6,0,.25); end);
	button:SetHandler("OnMouseExit", function(self) AuraMastery:Highlight(self.auraName.."TriggersMenuItem"..self.number.."_Backdrop", "background", 0,0,0,.4); end);
	button:SetHandler("OnClicked", function(self) AuraMastery:LoadTriggerMenu(self.number); end);
end

function AuraMastery:NewTrigger()
	self.activeTrigger = nil;
	WM:GetControlByName("AuraMasteryTriggerSettingsContainer"):SetHidden(false); 	-- show trigger settings
	local numTriggers = #self.svars.auraData[self.activeAura].triggers;
	
	self:CreateNewTrigger(self.activeAura);
	self.activeTrigger = numTriggers+1;

	self:LoadTriggerMenu(self.activeTrigger);
	self:ReloadTriggersList();
end

function AuraMastery:ReloadTriggersList()
	self:ClearTriggersList();

	for k, v in pairs(self.svars.auraData[self.activeAura].triggers) do
		self:CreateTriggersListItem(k, self.activeAura);
	end

	WM:GetControlByName("TriggersDropdownListButton_Label"):SetText("Condition "..self.activeTrigger);
end

function AuraMastery:LoadTriggerMenu(triggerNumber)
	WM:GetControlByName("AuraMasteryTriggerSettingsContainer"):SetHidden(false); 	-- show trigger settings
	WM:GetControlByName("TriggersDropdownList"):SetHidden(true); 						-- collapse trigger list
	local auraName = self.activeAura;

	if not self.svars.auraData[auraName].triggers then d("Achtung: Keine Bedingungen vorhanden."); end
	self.activeTrigger = triggerNumber;
	WM:GetControlByName("TriggersDropdownListButton_Label"):SetText("Condition "..self.activeTrigger);
	
	local EBAbilityId = WM:GetControlByName("AuraMasteryTriggerMenu_AbilityId_Editbox");
	EBAbilityId:SetText(self.svars.auraData[auraName].triggers[triggerNumber].spellId);

	local EBCheckAll = WM:GetControlByName("AuraMasteryCheckAllButton"):GetNamedChild("_Label");
	EBCheckAll:SetText(self.svars.auraData[auraName].triggers[triggerNumber].checkAll);

	local DDMOperator = WM:GetControlByName("AuraMasterySelectOperatorButton_Label");
	DDMOperator:SetText(self.svars.auraData[auraName].triggers[triggerNumber].operator);

	local EBValue = WM:GetControlByName("AuraMasteryTriggerMenu_Value_Editbox");
	EBValue:SetText(self.svars.auraData[auraName].triggers[triggerNumber].value);

	local EBInvert = WM:GetControlByName("AuraMasteryInvertButton"):GetNamedChild("_Label");
	EBInvert:SetText(self.svars.auraData[auraName].triggers[triggerNumber].invert);

	WM:GetControlByName("RemoveTrigger"):SetHandler("OnClicked", function() AuraMastery:DeleteTrigger(AuraMastery.activeAura, AuraMastery.activeTrigger); end);
end

function AuraMastery:CreateNewTrigger(auraName)
	local trigger = {
		['triggerType'] 	= 1,	-- icon, [label, status bar]
		['invert']			= "false",
		['checkAll']      = "false",
		['spellId']       = 0,
		['operator']		= ">",
		['value']			= 0
	}
	table.insert(self.svars.auraData[auraName].triggers, trigger);
end

function AuraMastery:DeleteTrigger(auraName, triggerIndex)
	table.remove(self.svars.auraData[auraName].triggers, triggerIndex);
	WM:GetControlByName("TriggersDropdownListButton_Label"):SetText("Select condition");
	WM:GetControlByName("AuraMasteryTriggerSettingsContainer"):SetHidden(true);
	self:CreateTriggersList();
	self:ReloadAuraControl(auraName);
end


--** Aura editing functions **--

function AuraMastery:EditAuraIcon(auraName, texturePath)
	if not self.svars.auraData[auraName] then d("Unknown aura: "..tostring(auraName)); return; end
	self.svars.auraData[auraName].iconPath = texturePath;
	self:CollapseMenu();
	d(auraName..": Icon \""..texturePath.."\" set.");
	self:ReloadAuraControl(auraName);
end

function AuraMastery:CollapseMenu()
	for k,v in self:pairsByKeys(self.iconData) do
		local categoryContainer = WM:GetControlByName("AuraMasteryMenuIconSelectMain"..k.."CategoryContainer");
		categoryContainer:SetHidden(true);
		for cat, cont in self:pairsByKeys(v) do
			local iconsContainer = WM:GetControlByName("AuraMasteryMenuIconSelectMain"..cat.."CategoryIconsContainer");
			iconsContainer:SetHidden(true);
		end
	end
	local menu = WM:GetControlByName("AuraMasteryMenuIconSelectMain");
	menu:SetHidden(true);
end

function AuraMastery:EditAuraName(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	control:LoseFocus();
end

function AuraMastery:EditAuraWidth(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%D")) 
		then d("Only integer values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].width);
	else
		self.svars.auraData[self.activeAura].width = tonumber(userInput);
		d("\""..self.activeAura.."\"'s width has been set to "..self.svars.auraData[self.activeAura].width..".");
	end
	control:LoseFocus();
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditAuraHeight(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%D")) then
		d("Only integer values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].height);
	else
		self.svars.auraData[self.activeAura].height = tonumber(userInput);
		d("\""..self.activeAura.."\"'s height has been set to "..self.svars.auraData[self.activeAura].height..".");
	end
	control:LoseFocus(); 
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditAuraPosX(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%D")) then
		d("Only integer values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].posX);
	else
		self.svars.auraData[self.activeAura].posX = tonumber(userInput);
		d("\""..self.activeAura.."\"'s x-coordinate has been set to "..self.svars.auraData[self.activeAura].posX..".");
	end
	control:LoseFocus();
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditAuraPosY(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%D")) then
		d("Only integer values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].posY);
	else
		self.svars.auraData[self.activeAura].posY = tonumber(userInput);
		d("\""..self.activeAura.."\"'s y-coordinate has been set to "..self.svars.auraData[self.activeAura].posY..".");
	end
	control:LoseFocus();
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditAuraAlpha(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%a")) then
		d("Only numeric values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].alpha);
	else
		self.svars.auraData[self.activeAura].alpha = tonumber(userInput);
		d("\""..self.activeAura.."\"'s transparency has been set to "..self.svars.auraData[self.activeAura].alpha..".");
	end
	control:LoseFocus();	
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditAuraFontSize(control)

	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%D")) then
		d("Only integer values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].fontSize);
	else
		self.svars.auraData[self.activeAura].fontSize = tonumber(userInput);
		d("\""..self.activeAura.."\"'s font size has been set to "..self.svars.auraData[self.activeAura].fontSize..".");
	end
	control:LoseFocus();	
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditAuraBorderSize(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%D")) then
		d("Only integer values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].borderSize);
	else
		self.svars.auraData[self.activeAura].borderSize = tonumber(userInput);
		d("\""..self.activeAura.."\"'s border size has been set to "..self.svars.auraData[self.activeAura].borderSize..".");
	end
	control:LoseFocus();	
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditAuraCritical(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%a")) then
		d("Only numeric values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].critical);
	else
		self.svars.auraData[self.activeAura].critical = tonumber(userInput);
		d("\""..self.activeAura.."\"'s critical time for decimal font cooldown display has been set to "..self.svars.auraData[self.activeAura].critical..".");
	end
	control:LoseFocus();
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditTriggerAbilityId(control)

	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%D")) 
		then d("Only integer values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].triggers[self.activeTrigger].spellId);
		return;
	else
		self.svars.auraData[self.activeAura].triggers[self.activeTrigger].spellId = tonumber(userInput);
		d("\""..self.activeAura.."\"'s ability id for trigger "..self.activeTrigger.." has been set to "..self.svars.auraData[self.activeAura].triggers[self.activeTrigger].spellId..".");
	end
	control:LoseFocus();
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditTriggerOperator(control)
	local legitOperators = {
		['<'] = "<",
		['>'] = ">",
		['<='] = "<=",
		['>='] = ">=",
		['='] = "==",
		['~='] = "~=",
	};
	local control = control:GetChild(2);	-- adress label subcontrol
	local userInput = self:trim(control:GetText());
	if (nil == legitOperators[userInput]) then
		d("Only legit operator values are allowed in this field (<, >, <=, >=, ==, ~=).");
		return;
	else
		WM:GetControlByName("OperatorsDrowpdownList"):SetHidden(true); 						-- collapse trigger list
		self.svars.auraData[self.activeAura].triggers[self.activeTrigger].operator = legitOperators[userInput];
		WM:GetControlByName("AuraMasterySelectOperatorButton_Label"):SetText(self.svars.auraData[self.activeAura].triggers[self.activeTrigger].operator);
		d("\""..self.activeAura.."\"'s operator for trigger "..self.activeTrigger.." has been set to "..self.svars.auraData[self.activeAura].triggers[self.activeTrigger].operator..".");
	end
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:EditTriggerValue(control)
	local userInput = self:trim(control:GetText());
	if "" == userInput then d("Please enter a (valid) value."); return; end;
	if (userInput:find("%a")) 
		then d("Only numeric values are allowed in this field.")
		control:SetText(self.svars.auraData[self.activeAura].triggers[self.activeTrigger].value);
		return;
	else
		self.svars.auraData[self.activeAura].triggers[self.activeTrigger].value = tonumber(userInput);
		d("\""..self.activeAura.."\"'s value id for trigger "..self.activeTrigger.." has been set to "..self.svars.auraData[self.activeAura].triggers[self.activeTrigger].value..".");
	end
	control:LoseFocus();
	self:ReloadAuraControl(self.activeAura);
end

function AuraMastery:Highlight(controlName, element, r, g, b, a)
	local control = WM:GetControlByName(controlName);
	if ("border") == element then
		control:SetEdgeColor(r, g, b, a);
	end
	if ("background") == element then
		control:SetCenterColor(r, g, b, a);
	end
end

--** Editbox functions **--

function AuraMastery:InvertTriggerLogic(control)
	local control = control:GetNamedChild("_Label");
	local value = control:GetText();
	if "true" == value then
		self.svars.auraData[self.activeAura].triggers[self.activeTrigger].invert = "false";
		control:SetText("false");
	else
		self.svars.auraData[self.activeAura].triggers[self.activeTrigger].invert = "true";
		control:SetText("true");
	end
end

function AuraMastery:CheckAll(control)
	local control = control:GetNamedChild("_Label");
	local value = control:GetText();
	if "true" == value then
		self.svars.auraData[self.activeAura].triggers[self.activeTrigger].checkAll = "false";
		control:SetText("false");
	else
		self.svars.auraData[self.activeAura].triggers[self.activeTrigger].checkAll = "true";
		control:SetText("true");
	end
end

--** Editbox Handlers **--

function AuraMastery:EditBoxOnMouseDown(controlName)
	local control = WM:GetControlByName(controlName);
	control:SelectAll();
	control:TakeFocus();
end

function AuraMastery:EditBoxOnMouseEnter(controlName)
	local control = WM:GetControlByName(controlName);
	local parentName = control:GetParent():GetName();
	local bgName = parentName.."_Backdrop";

	AuraMastery:Highlight(bgName, "border", 1,.6,0,1);
end

function AuraMastery:EditBoxOnMouseExit(controlName)
	local control = WM:GetControlByName(controlName);
	if not(control:HasFocus()) then 	
		local bgName = control:GetParent():GetName().."_Backdrop";
		AuraMastery:Highlight(bgName, "border", 1,1,1,.12);
	end
end

function AuraMastery:EditBoxOnEnter(controlName, field)
	local control = WM:GetControlByName(controlName);
	if not(self.activeAura) then d("Keine aktive Aura gesetzt beim Updateversuch."); return; end
	self.svars.auraData[self.activeAura][field] = control:GetText();
	control:LoseFocus();
end

function AuraMastery:EditBoxOnEscape(control, field)
	if "name" == field then
		control:SetText(self.activeAura);
	else 
		control:SetText(self.svars.auraData[self.activeAura][field]);
	end
	control:LoseFocus();
end

function AuraMastery:EditBoxOnTextChange(controlName)
end

function AuraMastery:EditBoxOnFocusLost(control)
	local parentName 	= control:GetParent():GetName();
	local bgName 		= parentName.."_Backdrop";

	AuraMastery:Highlight(bgName, "border", 1,1,1,.12);
end

function AuraMastery:FindAbilityIds()
	local textBox = WM:GetControlByName("FindIdsByNameContainer_Editbox_Editbox");
	local text = textBox:GetText();
	local parsedName = zo_strformat("<<z:1>>", text);
	textBox:SetText("");
	textBox:LoseFocus();
	local output = "";
	local lang = GetCVar("language.2");

	if (self.abilityData[lang][parsedName]) then
		output = output.."The following ability IDs have been found for \""..text.."\"\n";
		output = output..self.abilityData[lang][parsedName].rank1.. " (Rank 1)\n";
		output = output..self.abilityData[lang][parsedName].rank2.. " (Rank 2)\n";
		output = output..self.abilityData[lang][parsedName].rank3.. " (Rank 3)\n";
		output = output..self.abilityData[lang][parsedName].rank4.. " (Rank 4)\n";
	else
		output = "There is no ability named "..text..". Please check for typos.";
	end

	local resultsDisplay = WM:GetControlByName("FindIdsByNameContainer_Results_Label");
	resultsDisplay:SetText(output);
end